<?php

class tUserDataChecker {
  var $rules = array();
  var $data = array();
  var $errors = array();

  function getUserData($idata = NULL) {
    if ($idata == NULL) $idata = &$_REQUEST;
    foreach ($this->rules as $name => $rule) {
      $this->data[$name] = $idata[$name];
      $value = &$this->data[$name];
      // konverze
      switch($rule['convert']) {
        case 'int' : $value = (int)$value; break;
        case 'float' : $value = (float)$value; break;
        case 'trim' : $value = trim($value); break;
        case 'function' : $value = $rule['convert.function']($name, $data); break;
        case 'date_cz2iso' :
          if (ereg ('([0-9]{1,2})\.([0-9]{1,2})\.([0-9]{4})', $value, $regs)) {
            $value = sprintf('%04d-%02d-%02d', $regs[3],$regs[2],$regs[1]); 
          };
          break;
      };
      // kontrola
      switch($rule['check']) {
        case 'is_fill': // kontrola zda je pole vyplneno
          if ($value == '') $this->errors[$name] = 'empty';
          break;
        case 'is_email': // kontrola zda je v poly emailova adresa v platnem formatu
          if (!ereg('.+@.+\..+', $value)) $this->errors[$name] = 'no_email';
          break;
        case 'is_eq': // kontrola zda je shodny s jinym polem
          if ($value != $idata[$rule['check.is_eq']]) $this->errors[$name] = 'no_eq';
          break;
        case 'check_date' : // kontrola platnosti datumu
          if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $value, $regs)) {
            if (!checkdate ($regs[2], $regs[3], $regs[1])) {
              $this->errors[$name] = 'invalid_date';
            };
          } else {
              $this->errors[$name] = 'invalid_date_format';
          };
          break;
        case 'ereg' :
          if (!ereg ($rule['check.ereg'], $value))
            $this->errors[$name] = 'no_ereg';
          break;
        case 'preg' :
          if (!preg_match ($rule['check.preg'], $value))
            $this->errors[$name] = 'no_ereg';
          break;
        case 'function' : 
          $e = $rule['check.function']($name, $data);
          if ($e) $this->errors[$name] = $e; 
          break;
      };
    };
  }
}
?>
